CS::RenderManager::RenderTreeBase Class Reference (Crystal Space 2.0 Public API Reference)

| ## Public API Reference

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions
CS::RenderManager::RenderTreeBase Class Reference

Helper class containing stuff which doesn't require any of the template parameters to RenderTree. More...

`#include <csplugincommon/rendermanager/rendertree.h>`

Inheritance diagram for CS::RenderManager::RenderTreeBase:

List of all members.

## Public Member Functions
void | DrawDebugLines (iGraphics3D *g3d, RenderView *view)
| Render out debug lines (world space and screen space).
Debugging helpers: toggling of debugging features
uint | RegisterDebugFlag (const char *string)
| Register a debug flag, returns a numeric ID.
uint | QueryDebugFlag (const char *string)
| Query whether a debug flag was registered and return its ID or (uint)-1 if not registered.
bool | IsDebugFlagEnabled (uint flag) const
| Check whether a debug flag is enabled.
void | EnableDebugFlag (uint flag, bool state)
| Enable or disable a debug flag.
void | EnableDebugFlag (const char *flagStr, bool state)
| Enable or disable a debug flag.
Debugging helpers: debugging textures
void | AddDebugTexture (iTextureHandle *tex, float aspect=1.0f)
| Add a texture to be rendered at the bottom of the view the next frame.
void | RenderDebugTextures (iGraphics3D *g3d)
| Render out debug textures.
Debugging helpers: line drawing
See also: DrawDebugLines
void | AddDebugLine3D (const csVector3 &v1, const csVector3 &v2, const csColor &color1, const csColor &color2)
| Add debug line (world space)
void | AddDebugLine3DTF (const csVector3 &v1, const csVector3 &v2, const csTransform &toWorldSpace, const csColor &color1, const csColor &color2)
| Add debug line (arbitrary space, transformed to world space with toWorldSpace)
void | AddDebugBBox (const csBox3 &box, const csTransform &toWorldSpace, const csColor &col)
| Add lines to visualize a bounding box (in arbitrary space, transformed to world space with toWorldSpace)
void | AddDebugPlane (const csPlane3 &_plane, const csTransform &toWorldSpace, const csColor &col, const csVector3 &linesOrg=csVector3(0))
| Add lines to visualize a plane (in arbitrary space, transformed to world space with toWorldSpace)
void | AddDebugClipPlanes (RenderView *view)
| Visualize camera clip planes for the given view.
const DebugLines & | GetDebugLines () const
| Get all current debug lines. Useful to conserve the current lines.
void | SetDebugLines (const DebugLines &lines)
| Set all current debug lines.
Debugging helpers: screen space line drawing
See also: DrawDebugLines
void | AddDebugLineScreen (const csVector2 &v1, const csVector2 &v2, csRGBcolor color)
| Add a debug line (screen space - ie pixel coordinates!).

## Detailed Description

Helper class containing stuff which doesn't require any of the template parameters to RenderTree.

Definition at line 46 of file rendertree.h.

## Member Function Documentation

void CS::RenderManager::RenderTreeBase::AddDebugBBox | ( | const csBox3 & | box,
|  | const csTransform & | toWorldSpace,
|  | const csColor & | col
| ) |  |

Add lines to visualize a bounding box (in arbitrary space, transformed to world space with toWorldSpace)

void CS::RenderManager::RenderTreeBase::AddDebugClipPlanes | ( | RenderView * | view | ) |

Visualize camera clip planes for the given view.

void CS::RenderManager::RenderTreeBase::AddDebugLine3D | ( | const csVector3 & | v1,
|  | const csVector3 & | v2,
|  | const csColor & | color1,
|  | const csColor & | color2
| ) |  |

Add debug line (world space)

void CS::RenderManager::RenderTreeBase::AddDebugLine3DTF | ( | const csVector3 & | v1,
|  | const csVector3 & | v2,
|  | const csTransform & | toWorldSpace,
|  | const csColor & | color1,
|  | const csColor & | color2
| ) |  |

Add debug line (arbitrary space, transformed to world space with toWorldSpace)

void CS::RenderManager::RenderTreeBase::AddDebugLineScreen | ( | const csVector2 & | v1,
|  | const csVector2 & | v2,
|  | csRGBcolor | color
| ) |  |

Add a debug line (screen space - ie pixel coordinates!).

void CS::RenderManager::RenderTreeBase::AddDebugPlane | ( | const csPlane3 & | _plane,
|  | const csTransform & | toWorldSpace,
|  | const csColor & | col,
|  | const csVector3 & | linesOrg = `csVector3(0)`
| ) |  |

Add lines to visualize a plane (in arbitrary space, transformed to world space with toWorldSpace)

void CS::RenderManager::RenderTreeBase::AddDebugTexture | ( | iTextureHandle * | tex,
|  | float | aspect = `1.0f`
| ) |  |

Add a texture to be rendered at the bottom of the view the next frame.

void CS::RenderManager::RenderTreeBase::DrawDebugLines | ( | iGraphics3D * | g3d,
|  | RenderView * | view
| ) |  |

Render out debug lines (world space and screen space).

To be called by the rendermanager at the end of rendering a view.

void CS::RenderManager::RenderTreeBase::EnableDebugFlag | ( | uint | flag,
|  | bool | state
| ) |  | `[inline]`

Enable or disable a debug flag.

Remarks:
  Flag names are hierarchical. The hierarchy levels are separated by dots. If a flag is set or unset, all flags below in the hierarchy are set or unset as well.

Definition at line 103 of file rendertree.h.

void CS::RenderManager::RenderTreeBase::EnableDebugFlag | ( | const char * | flagStr,
|  | bool | state
| ) |  | `[inline]`

Enable or disable a debug flag.

Remarks:
  Flag names are hierarchical. The hierarchy levels are separated by dots. If a flag is set or unset, all flags below in the hierarchy are set or unset as well.

Definition at line 111 of file rendertree.h.

const DebugLines& CS::RenderManager::RenderTreeBase::GetDebugLines | ( |  | ) | const`[inline]`

Get all current debug lines. Useful to conserve the current lines.

Definition at line 172 of file rendertree.h.

bool CS::RenderManager::RenderTreeBase::IsDebugFlagEnabled | ( | uint | flag | ) | const`[inline]`

Check whether a debug flag is enabled.

Definition at line 95 of file rendertree.h.

uint CS::RenderManager::RenderTreeBase::QueryDebugFlag | ( | const char * | string | ) | `[inline]`

Query whether a debug flag was registered and return its ID or (uint)-1 if not registered.

Definition at line 91 of file rendertree.h.

uint CS::RenderManager::RenderTreeBase::RegisterDebugFlag | ( | const char * | string | ) | `[inline]`

Register a debug flag, returns a numeric ID.

Remarks:
  Flag names are hierarchical. The hierarchy levels are separated by dots. If a flag is set or unset, all flags below in the hierarchy are set or unset as well.

Definition at line 85 of file rendertree.h.

void CS::RenderManager::RenderTreeBase::RenderDebugTextures | ( | iGraphics3D * | g3d | ) |

Render out debug textures.

To be called by the rendermanager at the end of rendering a view.

void CS::RenderManager::RenderTreeBase::SetDebugLines | ( | const DebugLines & | lines | ) | `[inline]`

Set all current debug lines.

Useful to e.g. set conserved lines from an earlier frame.

Definition at line 177 of file rendertree.h.

The documentation for this class was generated from the following file:

- csplugincommon/rendermanager/rendertree.h